RUSTSEC-2023-0073: Vulnerability in candid

Rust Crates.io Security Advisory


History
Edit
JSON (OSV)

RUSTSEC-2023-0073

Infinite decoding loop through specially crafted payload


Reported
Issued

Package

candid
(crates.io)

Type

Vulnerability

Categories
Keywords

#candid

#canister

#icp

Aliases
References
CVSS Score
7.5
HIGH
CVSS Details
Attack vector
Network
Attack complexity
Low

Privileges required
None
User interaction
None
Scope
Unchanged
Confidentiality
None
Integrity
None
Availability
High
CVSS Vector
CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H
Patched
  • >=0.9.10
Unaffected
  • <0.9.0
Affected Functions
Version
candid::Decode
  • >=0.9.0, <0.9.10

Description

The Candid library causes a Denial of Service while parsing a specially crafted payload with empty data type. For example, if the payload is record { * ; empty } and the canister interface expects record { * } then the rust candid decoder treats empty as an extra field required by the type. The problem with type empty is that the candid rust library wrongly categorizes empty as a recoverable error when skipping the field and thus causing an infinite decoding loop.

Canisters using affected versions of candid are exposed to denial of service by causing the decoding to run indefinitely until the canister traps due to reaching maximum instruction limit per execution round. Repeated exposure to the payload will result in degraded performance of the canister.

For asset canister users, dfx versions >= 0.14.4 to <= 0.15.2-beta.0 ships asset canister with an affected version of candid.

Unaffected

  • Rust canisters using candid < 0.9.0 or >= 0.9.10
  • Rust canister interfaces of type other than record { * }
  • Motoko based canisters
  • dfx (for asset canister) <= 0.14.3 or >= 0.15.2

References

Advisory available under CC0-1.0
license.

READ MORE